require 'sequel'
require 'repositories/user_repo'

class Faccade

  # dependecy graph
  def initialize
    user_db = Sequel.sqlite
		create_user_tables(user_db)
    seed_users(user_db)
    @user_repo = UserRepo.new(user_db)
  end

  def create_user_tables(db)
    db.create_table :users do
      primary_key :id
      String :phone
      String :email
			String :password_digest
    end
  end

  def create_note_table(note_db)
    note_db.create_table :notes do
      primary_key :id
      String :content
    end
    note_db.create_table :hidden_table do
      primary_key :id
      String :content
    end
  end

  def user_exists?(identification)
    @user_repo.user_exists?(identification)
  end

	def login(identification, password)
    @user_repo.login(identification, password)
  end

  def seed_users(db)
    db[:users].insert(id: 1, phone: '0157 1337 42', email: 'john_doe@flow.go',   password_digest: '12345')
    db[:users].insert(id: 2, phone: '0157 1337 43', email: 'aohn_doe@flow.go',   password_digest: '12345')
    db[:users].insert(id: 3, phone: '0157 1337 44', email: 'bohn_doe@flow.go',   password_digest: '12345')
    db[:users].insert(id: 4, phone: '0157 1337 45', email: 'cohn_doe@flow.go',   password_digest: '12345')
    db[:users].insert(id: 5, phone: '0157 1337 46', email: 'dohn_doe@flow.go',   password_digest: '12345')
    db[:users].insert(id: 6, phone: '0157 1337 46', email: 'john_doe@notes.h18', password_digest: '12345')
  end

end
